Index: trunk/src/kernel32/cvtcursorgrp.cpp
===================================================================
--- trunk/src/kernel32/cvtcursorgrp.cpp	(revision 3100)
+++ trunk/src/kernel32/cvtcursorgrp.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: cvtcursorgrp.cpp,v 1.8 2000-02-16 14:25:37 sandervl Exp $ */
+/* $Id: cvtcursorgrp.cpp,v 1.9 2000-03-13 13:10:09 sandervl Exp $ */
 
 /*
@@ -17,5 +17,5 @@
 #define INCL_DOSMISC             /* DOS Miscellanous values  */
 #define INCL_WIN
-#include <os2.h>
+#include <os2wrap.h>
 #include <stdio.h>
 #include <string.h>
Index: trunk/src/kernel32/oslibdebug.cpp
===================================================================
--- trunk/src/kernel32/oslibdebug.cpp	(revision 3100)
+++ trunk/src/kernel32/oslibdebug.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibdebug.cpp,v 1.2 2000-02-16 14:25:44 sandervl Exp $ */
+/* $Id: oslibdebug.cpp,v 1.3 2000-03-13 13:10:10 sandervl Exp $ */
 
 /*
@@ -17,5 +17,5 @@
 #define INCL_DOSEXCEPTIONS
 #define INCL_DOSERRORS
-#include <os2.h>
+#include <os2wrap.h>
 #include <process.h>
 #include <os2sel.h>
Index: trunk/src/user32/gen_object.cpp
===================================================================
--- trunk/src/user32/gen_object.cpp	(revision 3100)
+++ trunk/src/user32/gen_object.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: gen_object.cpp,v 1.5 2000-02-16 14:34:19 sandervl Exp $ */
+/* $Id: gen_object.cpp,v 1.6 2000-03-13 13:10:45 sandervl Exp $ */
 /*
  * Generic Object Class for OS/2
@@ -11,5 +11,4 @@
  */
 #define  INCL_DOSSEMAPHORES
-#include <os2.h>
 #include <os2wrap.h>
 #include <stdlib.h>
Index: trunk/src/user32/initterm.cpp
===================================================================
--- trunk/src/user32/initterm.cpp	(revision 3100)
+++ trunk/src/user32/initterm.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: initterm.cpp,v 1.21 2000-02-16 14:34:20 sandervl Exp $ */
+/* $Id: initterm.cpp,v 1.22 2000-03-13 13:10:45 sandervl Exp $ */
 
 /*
@@ -35,4 +35,5 @@
 #include <misc.h>       /*PLF Wed  98-03-18 23:18:29*/
 #include <win32type.h>
+#include <winconst.h>
 #include <odinlx.h>
 #include <spy.h>
Index: trunk/src/user32/loadres.cpp
===================================================================
--- trunk/src/user32/loadres.cpp	(revision 3100)
+++ trunk/src/user32/loadres.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: loadres.cpp,v 1.24 2000-02-22 17:07:40 cbratschi Exp $ */
+/* $Id: loadres.cpp,v 1.25 2000-03-13 13:10:45 sandervl Exp $ */
 
 /*
@@ -23,5 +23,4 @@
 #include <heapstring.h>
 #include <oslibres.h>
-#include <winconst.h>
 #include <win\virtual.h>
 #include "dib.h"
Index: trunk/src/user32/oslibgdi.cpp
===================================================================
--- trunk/src/user32/oslibgdi.cpp	(revision 3100)
+++ trunk/src/user32/oslibgdi.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibgdi.cpp,v 1.10 2000-02-16 14:34:25 sandervl Exp $ */
+/* $Id: oslibgdi.cpp,v 1.11 2000-03-13 13:10:45 sandervl Exp $ */
 /*
  * Window GDI wrapper functions for OS/2
@@ -12,9 +12,9 @@
 #define  INCL_WIN
 #define  INCL_PM
-#include <os2.h>
 #include <os2wrap.h>
 #include <stdlib.h>
 #include <string.h>
 #include <misc.h>
+#include <winconst.h>
 #include <oslibgdi.h>
 #include <oslibwin.h>
Index: trunk/src/user32/oslibmenu.cpp
===================================================================
--- trunk/src/user32/oslibmenu.cpp	(revision 3100)
+++ trunk/src/user32/oslibmenu.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibmenu.cpp,v 1.11 2000-02-16 14:34:26 sandervl Exp $ */
+/* $Id: oslibmenu.cpp,v 1.12 2000-03-13 13:10:46 sandervl Exp $ */
 /*
  * Window Menu wrapper functions for OS/2
@@ -12,5 +12,4 @@
 #define  INCL_WIN
 #define  INCL_PM
-#include <os2.h>
 #include <os2wrap.h>
 #include <stdlib.h>
Index: trunk/src/user32/oslibmsg.cpp
===================================================================
--- trunk/src/user32/oslibmsg.cpp	(revision 3100)
+++ trunk/src/user32/oslibmsg.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibmsg.cpp,v 1.29 2000-02-29 19:16:11 sandervl Exp $ */
+/* $Id: oslibmsg.cpp,v 1.30 2000-03-13 13:10:46 sandervl Exp $ */
 /*
  * Window message translation functions for OS/2
@@ -20,9 +20,9 @@
 #define  INCL_PM
 #define  INCL_DOSPROCESS
-#include <os2.h>
 #include <os2wrap.h>
 #include <string.h>
 #include <misc.h>
 #include "oslibmsg.h"
+#include <winconst.h>
 #include <win32wnd.h>
 #include "oslibutil.h"
Index: trunk/src/user32/oslibmsgtranslate.cpp
===================================================================
--- trunk/src/user32/oslibmsgtranslate.cpp	(revision 3100)
+++ trunk/src/user32/oslibmsgtranslate.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibmsgtranslate.cpp,v 1.22 2000-03-09 21:50:11 sandervl Exp $ */
+/* $Id: oslibmsgtranslate.cpp,v 1.23 2000-03-13 13:10:46 sandervl Exp $ */
 /*
  * Window message translation functions for OS/2
@@ -18,8 +18,8 @@
 #define  INCL_PM
 #define  INCL_DOSPROCESS
-#include <os2.h>
 #include <os2wrap.h>
 #include <string.h>
 #include <misc.h>
+#include <winconst.h>
 #include "oslibmsg.h"
 #include "win32wnd.h"
Index: trunk/src/user32/oslibres.cpp
===================================================================
--- trunk/src/user32/oslibres.cpp	(revision 3100)
+++ trunk/src/user32/oslibres.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibres.cpp,v 1.9 2000-02-16 14:34:28 sandervl Exp $ */
+/* $Id: oslibres.cpp,v 1.10 2000-03-13 13:10:47 sandervl Exp $ */
 /*
  * Window API wrappers for OS/2
@@ -12,5 +12,4 @@
 #define  INCL_WIN
 #define  INCL_PM
-#include <os2.h>
 #include <os2wrap.h>
 #include <stdlib.h>
Index: trunk/src/user32/oslibwin.cpp
===================================================================
--- trunk/src/user32/oslibwin.cpp	(revision 3100)
+++ trunk/src/user32/oslibwin.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: oslibwin.cpp,v 1.69 2000-02-16 14:34:29 sandervl Exp $ */
+/* $Id: oslibwin.cpp,v 1.70 2000-03-13 13:10:47 sandervl Exp $ */
 /*
  * Window API wrappers for OS/2
@@ -13,5 +13,4 @@
 #define  INCL_WIN
 #define  INCL_PM
-#include <os2.h>
 #include <os2wrap.h>
 #include <stdlib.h>
Index: trunk/src/user32/pmframe.cpp
===================================================================
--- trunk/src/user32/pmframe.cpp	(revision 3100)
+++ trunk/src/user32/pmframe.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: pmframe.cpp,v 1.44 2000-03-01 13:30:05 sandervl Exp $ */
+/* $Id: pmframe.cpp,v 1.45 2000-03-13 13:10:47 sandervl Exp $ */
 /*
  * Win32 Frame Managment Code for OS/2
@@ -16,5 +16,6 @@
 #include <stdlib.h>
 #include <string.h>
-#include "win32type.h"
+#include <win32type.h>
+#include <winconst.h>
 #include <misc.h>
 #include <win32wbase.h>
Index: trunk/src/user32/pmwindow.cpp
===================================================================
--- trunk/src/user32/pmwindow.cpp	(revision 3100)
+++ trunk/src/user32/pmwindow.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: pmwindow.cpp,v 1.86 2000-02-20 18:28:32 cbratschi Exp $ */
+/* $Id: pmwindow.cpp,v 1.87 2000-03-13 13:10:47 sandervl Exp $ */
 /*
  * Win32 Window Managment Code for OS/2
@@ -19,5 +19,5 @@
 #include <stdlib.h>
 #include <string.h>
-#include "win32type.h"
+#include <win32type.h>
 #include <winconst.h>
 #include <wprocess.h>
Index: trunk/src/user32/spy.cpp
===================================================================
--- trunk/src/user32/spy.cpp	(revision 3100)
+++ trunk/src/user32/spy.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: spy.cpp,v 1.10 2000-02-16 14:34:33 sandervl Exp $ */
+/* $Id: spy.cpp,v 1.11 2000-03-13 13:10:48 sandervl Exp $ */
 
 /*
@@ -16,5 +16,4 @@
 #define INCL_DOSERRORS
 #define INCL_DOSSEMAPHORES
-#include <os2.h>
 #include <os2wrap.h>
 
Index: trunk/src/user32/timer.cpp
===================================================================
--- trunk/src/user32/timer.cpp	(revision 3100)
+++ trunk/src/user32/timer.cpp	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: timer.cpp,v 1.11 2000-02-16 14:34:36 sandervl Exp $ */
+/* $Id: timer.cpp,v 1.12 2000-03-13 13:10:48 sandervl Exp $ */
 
 /*
@@ -13,5 +13,5 @@
 #define INCL_WIN
 #define INCL_DOSSEMAPHORES
-#include <os2.h>
+#include <os2wrap.h>
 #include <os2sel.h>
 #include <stdlib.h>
Index: trunk/src/user32/win32wbase.h
===================================================================
--- trunk/src/user32/win32wbase.h	(revision 3100)
+++ trunk/src/user32/win32wbase.h	(revision 3101)
@@ -1,3 +1,3 @@
-/* $Id: win32wbase.h,v 1.87 2000-03-01 13:30:06 sandervl Exp $ */
+/* $Id: win32wbase.h,v 1.88 2000-03-13 13:10:48 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2
@@ -21,5 +21,4 @@
 #include <win32wndchild.h>
 #include <winres.h>
-#include <winconst.h>
 #include <scroll.h>
 
@@ -431,5 +430,9 @@
          VOID  AdjustTrackInfo(PPOINT minTrackSize,PPOINT maxTrackSize);
 
+#ifndef OS2_INCLUDED
+         BOOL   isOwnDC() { return (windowClass && windowClass->getStyle() & CS_OWNDC); }
+#else
          BOOL   isOwnDC() { return (windowClass && windowClass->getStyle() & CS_OWNDC_W); }
+#endif
          HDC    getOwnDC() { return ownDC; }
          void   setOwnDC(HDC hdc) { ownDC = hdc; }