Index: /trunk/essentials/sys-devel/automake-1.4/Makefile.kmk
===================================================================
--- /trunk/essentials/sys-devel/automake-1.4/Makefile.kmk	(revision 3137)
+++ /trunk/essentials/sys-devel/automake-1.4/Makefile.kmk	(revision 3137)
@@ -0,0 +1,44 @@
+# $Id: Makefile.kmk 3094 2007-04-10 02:30:26Z bird $
+## @file
+#
+# kNIX Makefile for autoconf
+#
+# Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+#
+#
+# This file is part of kNIX.
+#
+# kNIX is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kNIX is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kNIX; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+ifdef NOT_BOOTSTRAPPING_KNIX
+
+PM_VERSION = 1.4-p6
+
+OPT_BUILD  = "PERL=perl.exe" "SHELL=sh.exe" "M4=m4.exe" "AWK=gawk.exe"
+SET_CONFIG = ac_cv_path_PERL="perl.exe"
+OPT_CONFIG = --program-suffix="-1.4"
+OPT_INSTALL = "pkgdatadir=$(pm_pubdirbase)/usr/share/automake-1.4" \
+              "m4datadir=$(pm_pubdirbase)/usr/share/aclocal-1.4"
+pm_topdir := ../../..
+include $(pm_topdir)/ports-make/gnugccomf.gmk
+
+else
+
+include kNIX-bootstrap.kmk
+
+endif
+
Index: /trunk/essentials/sys-devel/automake-1.4/kNIX-bootstrap.kmk
===================================================================
--- /trunk/essentials/sys-devel/automake-1.4/kNIX-bootstrap.kmk	(revision 3137)
+++ /trunk/essentials/sys-devel/automake-1.4/kNIX-bootstrap.kmk	(revision 3137)
@@ -0,0 +1,174 @@
+# $Id: kNIX-bootstrap.kmk 3116 2007-04-15 18:41:33Z bird $
+## @file
+#
+# kNIX Boostrap Makefile for automake 1.4
+#
+# Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+#
+#
+# This file is part of kNIX.
+#
+# kNIX is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kNIX is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kNIX; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+DEPTH = ../../..
+include $(PATH_KBUILD)/header.kmk
+
+# HASH
+ifndef HASH
+HASH :=\#
+endif
+
+# The automake version.
+VER = 1.4
+FULL_VER = 1.4-p6
+
+#
+# /usr/bin/
+#
+INSTALLS += automake-bin
+automake-bin_TEMPLATE = usr.bin
+automake-bin_SOURCES = \
+	$(PATH_TARGET)/automake-$(VER) \
+	$(PATH_TARGET)/aclocal-$(VER)
+
+# Edit function used to transform *.in and m4/*.in files.
+EDIT_FILE = $(SED) \
+		-e 's|@PERL[@]|perl.exe|g' \
+		-e 's|@TAR[@]|tar.exe|g' \
+		-e 's|@prefix[@]|/usr|g' \
+		-e 's|@VERSION[@]|$(FULL_VER)|g' \
+		-e 's|@APIVERSION[@]|$(VER)|g' \
+		-e 's|@PACKAGE[@]|automake|g' \
+		-e 's|@PACKAGE_NAME[@]|GNU Automake|g' \
+		-e 's|@configure_input[@]|$(basename $1). Generated from $1 by kBuild.|g' \
+
+# The file edit rules.
+define def_automake-bin
+$(PATH_TARGET)/$(name)-$(VER): $(name).in #kNIX-bootstrap.kmk
+	$(QUIET)$(MKDIR) -p $$(@D)
+	$(call EDIT_FILE,$(name)) $$< > $$@.tmp
+	$(INSTALL) -m a+x,a-w $$@.tmp $$@
+	$(RM) -f $$@.tmp
+endef
+$(foreach name, aclocal automake, \
+$(eval $(def_automake-bin)))
+
+#
+# /usr/share/automake-x.y
+#
+INSTALLS += share-automake
+share-automake_TEMPLATE = gendata
+share-automake_INST = usr/share/automake-$(VER)/
+share-automake_SOURCES = \
+	COPYING \
+	INSTALL \
+	texinfo.tex \
+	ansi2knr.c \
+	ansi2knr.1 \
+	config.sub \
+	\
+	clean-hdr.am \
+	clean-kr.am \
+	clean.am \
+	comp-vars.am \
+	compile.am \
+	data-clean.am \
+	data.am \
+	dejagnu.am \
+	depend.am \
+	depend2.am \
+	dist-vars.am \
+	footer.am \
+	header-vars.am \
+	header.am \
+	java-clean.am \
+	java.am \
+	kr-extra.am \
+	library.am \
+	libs-clean.am \
+	libs.am \
+	libtool.am \
+	lisp-clean.am \
+	lisp.am \
+	ltlib-clean.am \
+	ltlib.am \
+	ltlibrary.am \
+	mans-vars.am \
+	mans.am \
+	multilib.am \
+	program.am \
+	progs-clean.am \
+	progs.am \
+	remake-hdr.am \
+	remake.am \
+	scripts.am \
+	subdirs.am \
+	tags-clean.am \
+	tags.am \
+	texi-vers.am \
+	texinfos.am \
+
+INSTALLS += share-automake-exec
+share-automake-exec_TEMPLATE = gendata
+share-automake-exec_MODE = 755
+share-automake-exec_INST = usr/share/automake-$(VER)/
+share-automake-exec_SOURCES = \
+	acinstall \
+	config.guess \
+	elisp-comp \
+	install-sh \
+	mdate-sh \
+	missing \
+	mkinstalldirs \
+	ylwrap \
+
+#
+# /usr/share/aclocal-x.y
+#
+INSTALLS += share-aclocal
+share-aclocal_TEMPLATE = gendata
+share-aclocal_INST = usr/share/aclocal-$(VER)/
+share-aclocal_SOURCES = \
+	m4/ccstdc.m4 \
+	m4/cond.m4 \
+	m4/dmalloc.m4 \
+	m4/error.m4 \
+	m4/header.m4 \
+	m4/init.m4 \
+	m4/lex.m4 \
+	m4/lispdir.m4 \
+	m4/maintainer.m4 \
+	m4/missing.m4 \
+	m4/mktime.m4 \
+	m4/multi.m4 \
+	m4/obstack.m4 \
+	m4/protos.m4 \
+	m4/ptrdiff.m4 \
+	m4/regex.m4 \
+	m4/sanity.m4 \
+	m4/strtod.m4 \
+	m4/termios.m4 \
+	m4/winsz.m4 \
+	$(PATH_TARGET)/m4/amversion.m4
+
+$(PATH_TARGET)/m4/amversion.m4: m4/amversion.in #kNIX-bootstrap.kmk
+	$(QUIET)$(MKDIR) -p $(@D)
+	$(call EDIT_FILE,amversion.in) $< > $@
+
+
+include $(PATH_KBUILD)/footer.kmk
+