Index: /trunk/essentials/sys-devel/automake-1.9/Makefile.kmk
===================================================================
--- /trunk/essentials/sys-devel/automake-1.9/Makefile.kmk	(revision 3146)
+++ /trunk/essentials/sys-devel/automake-1.9/Makefile.kmk	(revision 3146)
@@ -0,0 +1,49 @@
+# $Id: Makefile.kmk 3094 2007-04-10 02:30:26Z bird $
+## @file
+#
+# kNIX Makefile for automake 1.8.x
+#
+# Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+#
+#
+# This file is part of kNIX.
+#
+# kNIX is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kNIX is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kNIX; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+ifdef NOT_BOOTSTRAPPING_KNIX
+
+PM_VERSION = 1.9.6
+
+# tmp hack
+ACLOCAL = aclocal-1.8
+AUTOMAKE = automake-1.8
+
+SET_CONFIG = "PERL=perl.exe" "SHELL=sh.exe" "M4=m4.exe" "AWK=gawk.exe" "TAR=tar.exe"
+OPT_BUILD  = "PERL=perl.exe" "SHELL=sh.exe" "M4=m4.exe" "AWK=gawk.exe" "TAR=tar.exe"
+SET_CONFIG = ac_cv_path_PERL="perl.exe"
+OPT_CONFIG = --program-suffix="-1.9"
+OPT_INSTALL = "pkgdatadir=$(pm_pubdirbase)/usr/share/automake-1.9" \
+              "m4datadir=$(pm_pubdirbase)/usr/share/aclocal-1.9"
+pm_topdir := ../../..
+include $(pm_topdir)/ports-make/gnugccomf.gmk
+
+else
+
+include kNIX-bootstrap.kmk
+
+endif
+
Index: /trunk/essentials/sys-devel/automake-1.9/kNIX-bootstrap.kmk
===================================================================
--- /trunk/essentials/sys-devel/automake-1.9/kNIX-bootstrap.kmk	(revision 3146)
+++ /trunk/essentials/sys-devel/automake-1.9/kNIX-bootstrap.kmk	(revision 3146)
@@ -0,0 +1,213 @@
+# $Id: kNIX-bootstrap.kmk 3116 2007-04-15 18:41:33Z bird $
+## @file
+#
+# kNIX Boostrap Makefile for automake 1.9
+#
+# Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+#
+#
+# This file is part of kNIX.
+#
+# kNIX is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kNIX is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kNIX; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+DEPTH = ../../..
+include $(PATH_KBUILD)/header.kmk
+
+# The automake version.
+VER = 1.9
+FULL_VER = 1.9.6
+
+# Edit function used to transform *.in, m4/*.in and lib/Automake/*.in files.
+EDIT_FILE = $(SED) \
+		-e 's|@SHELL[@]|sh.exe|g' \
+		-e 's|@PERL[@]|perl.exe|g' \
+		-e 's|@TAR[@]|tar.exe|g' \
+		-e 's|@prefix[@]|/usr|g' \
+		-e 's|@datadir[@]|/usr/share|g' \
+		-e 's|@PATH_SEPARATOR[@]|;|g' \
+		-e 's|@VERSION[@]|$(FULL_VER)|g' \
+		-e 's|@APIVERSION[@]|$(VER)|g' \
+		-e 's|@PACKAGE[@]|automake|g' \
+		-e 's|@PACKAGE_NAME[@]|GNU Automake|g' \
+		-e 's|@configure_input[@]|$(basename $1). Generated from $1 by kBuild.|g' \
+
+#
+# /usr/bin/
+#
+INSTALLS += automake-bin
+automake-bin_TEMPLATE = usr.bin
+automake-bin_SOURCES = \
+	$(PATH_TARGET)/automake-$(VER) \
+	$(PATH_TARGET)/aclocal-$(VER)
+
+# The file edit rules.
+define def_automake-bin
+$(PATH_TARGET)/$(name)-$(VER): $(name).in kNIX-bootstrap.kmk
+	$(QUIET)$(MKDIR) -p $$(@D)
+	$(call EDIT_FILE,$(name)) $$< > $$@.tmp
+	$(INSTALL) -m a+x,a-w $$@.tmp $$@
+	$(RM) -f $$@.tmp
+endef
+$(foreach name, aclocal automake, \
+$(eval $(def_automake-bin)))
+
+#
+# /usr/share/automake-x.y
+#
+INSTALLS += share-automake
+share-automake_TEMPLATE = gendata
+share-automake_INST = usr/share/automake-$(VER)/
+share-automake_SOURCES = \
+	lib/COPYING \
+	lib/INSTALL \
+	lib/texinfo.tex \
+	lib/ansi2knr.c \
+	lib/ansi2knr.1 \
+	lib/config-ml.in \
+	lib/config.guess \
+	lib/config.sub \
+	lib/install-sh \
+	lib/mdate-sh \
+	lib/missing \
+	lib/mkinstalldirs \
+	lib/elisp-comp \
+	lib/ylwrap \
+	lib/acinstall \
+	lib/depcomp \
+	lib/compile \
+	lib/py-compile \
+	lib/symlink-tree \
+
+INSTALLS += share-automake-Automake
+share-automake-Automake_TEMPLATE = gendata
+share-automake-Automake_INST = usr/share/automake-$(VER)/Automake/
+share-automake-Automake_SOURCES = \
+	lib/Automake/ChannelDefs.pm \
+	lib/Automake/Channels.pm \
+	lib/Automake/Condition.pm \
+	lib/Automake/Configure_ac.pm \
+	lib/Automake/DisjConditions.pm \
+	lib/Automake/FileUtils.pm \
+	lib/Automake/General.pm \
+	lib/Automake/Item.pm \
+	lib/Automake/ItemDef.pm \
+	lib/Automake/Location.pm \
+	lib/Automake/Options.pm \
+	lib/Automake/Rule.pm \
+	lib/Automake/RuleDef.pm \
+	lib/Automake/Struct.pm \
+	lib/Automake/Variable.pm \
+	lib/Automake/VarDef.pm \
+	lib/Automake/Version.pm \
+	lib/Automake/XFile.pm \
+	lib/Automake/Wrap.pm \
+	$(PATH_TARGET)/lib/Automake/Config.pm
+
+$(PATH_TARGET)/lib/Automake/Config.pm: lib/Automake/Config.in
+	$(QUIET)$(MKDIR) -p $(@D)
+	$(call EDIT_FILE,Config.in) $< > $@
+
+INSTALLS += share-automake-am
+share-automake-am_TEMPLATE = gendata
+share-automake-am_INST = usr/share/automake-$(VER)/am/
+share-automake-am_SOURCES = \
+	lib/am/ansi2knr.am \
+	lib/am/check.am \
+	lib/am/clean-hdr.am \
+	lib/am/clean.am \
+	lib/am/compile.am \
+	lib/am/configure.am \
+	lib/am/data.am \
+	lib/am/dejagnu.am \
+	lib/am/depend.am \
+	lib/am/depend2.am \
+	lib/am/distdir.am \
+	lib/am/footer.am \
+	lib/am/header-vars.am \
+	lib/am/header.am \
+	lib/am/install.am \
+	lib/am/inst-vars.am \
+	lib/am/java.am \
+	lib/am/lang-compile.am \
+	lib/am/lex.am \
+	lib/am/library.am \
+	lib/am/libs.am \
+	lib/am/libtool.am \
+	lib/am/lisp.am \
+	lib/am/ltlib.am \
+	lib/am/ltlibrary.am \
+	lib/am/mans-vars.am \
+	lib/am/mans.am \
+	lib/am/multilib.am \
+	lib/am/program.am \
+	lib/am/progs.am \
+	lib/am/python.am \
+	lib/am/remake-hdr.am \
+	lib/am/scripts.am \
+	lib/am/subdirs.am \
+	lib/am/tags.am \
+	lib/am/texi-vers.am \
+	lib/am/texibuild.am \
+	lib/am/texinfos.am \
+	lib/am/yacc.am \
+
+#
+# /usr/share/aclocal-x.y
+#
+INSTALLS += share-aclocal
+share-aclocal_TEMPLATE = gendata
+share-aclocal_INST = usr/share/aclocal-$(VER)/
+share-aclocal_SOURCES = \
+	m4/as.m4 \
+	m4/auxdir.m4 \
+	m4/ccstdc.m4 \
+	m4/cond.m4 \
+	m4/depend.m4 \
+	m4/depout.m4 \
+	m4/dmalloc.m4 \
+	m4/gcj.m4 \
+	m4/header.m4 \
+	m4/init.m4 \
+	m4/install-sh.m4 \
+	m4/lead-dot.m4 \
+	m4/lex.m4 \
+	m4/lispdir.m4 \
+	m4/maintainer.m4 \
+	m4/make.m4 \
+	m4/minuso.m4 \
+	m4/missing.m4 \
+	m4/mkdirp.m4 \
+	m4/multi.m4 \
+	m4/obsol-gt.m4 \
+	m4/obsol-lt.m4 \
+	m4/obsolete.m4 \
+	m4/options.m4 \
+	m4/protos.m4 \
+	m4/python.m4 \
+	m4/regex.m4 \
+	m4/runlog.m4 \
+	m4/sanity.m4 \
+	m4/strip.m4 \
+	m4/tar.m4 \
+	$(PATH_TARGET)/m4/amversion.m4
+
+$(PATH_TARGET)/m4/amversion.m4: m4/amversion.in kNIX-bootstrap.kmk
+	$(QUIET)$(MKDIR) -p $(@D)
+	$(call EDIT_FILE,amversion.in) $< > $@
+
+include $(PATH_KBUILD)/footer.kmk
+